uses graphlib, crt;

type rect = record
              x1, y1, x2, y2 : word;
            end;

var
    pal : gltPalette;
    i   : byte;
    bmp : gltBitMap;
    fnt : gltFont;


procedure RenderFractal( var bm : gltBitMap;
                         h1, h2, h3, h4, d : word );

  var rt : rect;

  function  GetPoint( x, y : word ) : word;
    begin
      GetPoint := bm.addr^[ y * bm.D + x ];
    end;

  procedure PutPoint( x, y, c : word );
    begin
      bm.addr^[ y * bm.D + x ] := c;
    end;

  procedure ShowAll( r : rect; depth : word );
    var
        x12, y12, h1, h2, h3, h4 : word;
        k1, k2, k3         : real;
        r0                 : rect;
    begin

      if depth > d then exit;

      x12 := (r.x2+r.x1) div 2;
      y12 := (r.y2+r.y1) div 2;

      h1 := GetPoint( r.x1, r.y1 );
      h2 := GetPoint( r.x2, r.y1 );
      h3 := GetPoint( r.x2, r.y2 );
      h4 := GetPoint( r.x1, r.y2 );

      if GetPoint( x12, r.y1 ) = 255
        then
          begin
            k1 := random;
            PutPoint( x12, r.y1, round( h1*k1 + h2*(1-k1)) );
          end;

      if GetPoint( r.x2, y12 ) = 255
        then
          begin
            k1 := random;
            PutPoint( r.x2, y12, round( h2*k1 + h3*(1-k1)) );
          end;

      if GetPoint( x12, r.y2 ) = 255
        then
          begin
            k1 := random;
            PutPoint( x12, r.y2, round( h3*k1 + h4*(1-k1)) );
          end;

      if GetPoint( r.x1, y12 ) = 255
        then
          begin
            k1 := random;
            PutPoint( r.x1, y12, round( h4*k1 + h1*(1-k1)) );
          end;

      k1 := random / 3.;
      k2 := random / 3.;
      k3 := random / 3.;
      PutPoint( x12, y12, round( h1*k1 + h2*k2 + h3*k3 + h4*(1-k1-k2-k3)) );

      with r0 do
       begin
        x1 := r.x1;
        x2 := x12;
        y1 := r.y1;
        y2 := y12;
       end;
      ShowAll( r0, depth + 1 );

      with r0 do
       begin
        x2 := r.x2;
        x1 := x12;
        y1 := r.y1;
        y2 := y12;
       end;
      ShowAll( r0, depth + 1 );

      with r0 do
       begin
        x1 := r.x1;
        x2 := x12;
        y2 := r.y2;
        y1 := y12;
       end;
      ShowAll( r0, depth + 1 );

      with r0 do
       begin
        x2 := r.x2;
        x1 := x12;
        y2 := r.y2;
        y1 := y12;
       end;
      ShowAll( r0, depth + 1 );
    end;

  begin
    glClearBitMap( bm, 255 );

    with rt do
     begin
      x1 := 0;
      y1 := 0;
      x2 := bm.D-1;
      y2 := bm.H-1;
      glPoint( bm, x1, y1, h1 );
      glPoint( bm, x2, y1, h2 );
      glPoint( bm, x2, y2, h3 );
      glPoint( bm, x1, y2, h4 );
     end;


    ShowAll( rt, 1 );
  end;

Begin
  randomize;
  glInit320x200;



  for i := 0 to 63 do
    pal[i*3] := i;
  for i := 64 to 127 do
    pal[i*3+1] := i;
  for i := 128 to 126+63 do
    pal[i*3+2] := i;
  pal[600] := 30;
  pal[601] := 30;
  pal[602] := 30;
  glSetPalette( pal );


  glReadFont( 'font.fnt', fnt, AllocateOn );
  glSetFont( fnt );
  glCreateBitMap( bmp, 320, 200 );
  repeat
    RenderFractal( Screen, 20, 60, 20, 60, 9 );
    glPutString( Screen, 68, 190, 'Press any key...ESC for exit...', 100 );
    ch := readkey;
  until ch = #27;
  glDeleteBitMap( bmp );
  glClose320x200;

End.
